<template>
    <div class="editskill">
        <h2>Edit Skills</h2>

        <form @submit.prevent = "updateSkill">
            <input type="text" placeholder="" v-model = "name" required>
            <input type="text" placeholder="" v-model = "type" required>
            <input type="text" placeholder="" v-model = "skill_id" required disabled>


            <div class="buttonClass">
                <router-link to="/skill"><button class="btn-cancel">CANCEL</button></router-link>
                <button type="submit" class="btn-submit">UPDATE</button>
            </div>

        </form>

    </div>
</template>

<script>
    import db from '@/db'
    export default {
        name: 'editskill',

        data () {
            return {
                skill_id: null,
                name: null,
                type: null
            }

        },

        beforeRouteEnter(to, from, next) {
            db.collection('myskills').where('skill_id', '==', to.params.skill_id).
                get().then(querySnapshop => {
                    querySnapshop.forEach(doc => {
                        next(vm => {
                            vm.skill_id = doc.data().skill_id
                            vm.name = doc.data().name
                            vm.type = doc.data().type

                        })
                    })
            })
        },

        watch : {
            '$route' : 'getData'
        },

        methods : {

            getData() {
                db.collection('myskills').where('skill_id', '==', this.$route.params.skill_id).get().
                    then(querySnapshot => {
                        querySnapshot.forEach(doc => {
                            this.skill_id = doc.data().skill_id
                            this.name = doc.data().name
                            this.type = doc.data().type
                        })
                })
            },

            updateSkill() {
                db.collection('myskills').where('skill_id', '==', this.$route.params.skill_id).get().
                then(querySnapshot => {
                    querySnapshot.forEach(doc => {
                        doc.ref.update({
                        skill_id : this.skill_id,
                        name : this.name,
                        type : this.type
                        }).then(() => this.$router.push('/skill'))

                    })
                })
            }
        }


    }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
    h2 {
        text-align: center;
    }
    input {
        width: calc(100% - 40px);
        padding: 20px;
        border: 0;
        font-size: 1.3em;
        background-color: #323333;
        color: #687F7F;
        margin-top: 5px;
        box-shadow: 0px 5px 5px #888888;
    }

    p {
        text-align:center;
        padding: 30px 0;
        color: gray;
    }

    .buttonClass {
        display: flex;
        width: 50%;
        margin-left: auto;
        margin-right: auto;
        padding: 30px;
        justify-content: center;

        button {
            box-shadow: 0 0 5px -1px rgba(0,0,0,0.2);
            border: 1px solid transparent;
            cursor:pointer;
            padding: 8px;
            width: 170px;
            margin-right: 20px;
            -moz-border-radius: 2px;
            border-radius: 2px;
        }

        .btn-submit {
            background-color: #1e999e;
            color: beige;
        }

        .btn-cancel {
            background-color: #e12c51;
            color: beige;
        }
    }
</style>
